<?php

namespace Drupal\facets_form_searchbox_widget\Plugin\facets\widget;

use Drupal\Core\Render\RendererInterface;
use Drupal\facets_form\FacetsFormWidgetTrait;
use Drupal\facets_form\FacetsFormWidgetInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\facets_searchbox_widget\Plugin\facets\widget\SearchboxCheckboxWidget;

/**
 * Extend the original class and implement facets_form interface.
 *
 * @FacetsWidget(
 *   id = "facets_form_searchbox_checkbox_widget",
 *   label = @Translation("Searchable list of checkboxes (inside form)"),
 *   description = @Translation("A configurable widget that provides a search input with checkboxes display."),
 * )
 */
class FacetsFormSearchBoxCheckBoxWidget extends SearchboxCheckboxWidget implements FacetsFormWidgetInterface, ContainerFactoryPluginInterface {

  use FacetsFormWidgetTrait;

  /**
   * The renderer service.
   *
   * @var \Drupal\Core\Render\RendererInterface
   */
  protected $renderer;

  /**
   * Constructs a new facet plugin instance.
   *
   * @param array $configuration
   *   A configuration array containing information about the plugin instance.
   * @param string $plugin_id
   *   The plugin_id for the plugin instance.
   * @param mixed $plugin_definition
   *   The plugin implementation definition.
   * @param \Drupal\Core\Render\RendererInterface $renderer
   *   The renderer service.
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition, RendererInterface $renderer) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->renderer = $renderer;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition): self {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('renderer')
    );
  }

}
